package com.jasamedika.medifirst2000.service.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.BaseConverterImpl;
import com.jasamedika.medifirst2000.dao.KeluhanPelangganDao;
import com.jasamedika.medifirst2000.entities.KeluhanPelanggan;
import com.jasamedika.medifirst2000.entities.Pekerjaan;
import com.jasamedika.medifirst2000.entities.Ruangan;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.KeluhanPelangganService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.util.DateUtil;
import com.jasamedika.medifirst2000.vo.KeluhanPelangganVO;
import com.jasamedika.medifirst2000.vo.PekerjaanVO;
import com.jasamedika.medifirst2000.vo.RuanganVO;

@Service("KeluhanPelangganService")
public class KeluhanPelangganServiceImpl extends BaseVoServiceImpl implements KeluhanPelangganService{
	
	@Autowired
	private KeluhanPelangganDao keluhanPelangganDao;
	
	@Autowired
	private BaseConverterImpl<KeluhanPelangganVO, KeluhanPelanggan> keluhanPelangganConverter;
	
	@Autowired
	private BaseConverterImpl<RuanganVO, Ruangan> ruanganConverter;
	
	@Autowired
	private BaseConverterImpl<PekerjaanVO, Pekerjaan> pekerjaanConverter;
	
	@Override
	public KeluhanPelangganVO add(KeluhanPelangganVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public KeluhanPelangganVO update(KeluhanPelangganVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public KeluhanPelangganVO findById(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<KeluhanPelangganVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}
	
	
	// =========================================================================================================== //
	
	@Override
	public Map<String, Object> addKeluhanPelanggan(KeluhanPelangganVO vo) {
		KeluhanPelanggan keluhanPelanggan = new KeluhanPelanggan();
		
		Date dateNow = DateUtil.now();
		
		if(CommonUtil.isNotNullOrEmpty(vo)){
			keluhanPelanggan = keluhanPelangganConverter.transferVOToModel(vo, new KeluhanPelanggan());
			keluhanPelanggan.setTglKeluhan(vo.getTglKeluhan());
		}
		
		if(CommonUtil.isNotNullOrEmpty(vo.getRuangan())){
			keluhanPelanggan.setRuangan(ruanganConverter.transferVOToModel(vo.getRuangan(), new Ruangan()));
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getPekerjaan())){
			keluhanPelanggan.setPekerjaan(pekerjaanConverter.transferVOToModel(vo.getPekerjaan(), new Pekerjaan()));
		}
		
		//add by iwankasan 19062017
		if(CommonUtil.isNotNullOrEmpty(vo.getTglOrder())) {
			keluhanPelanggan.setTglOrder(dateNow);
		}
		
		Map<String, Object> result = new HashMap<String,Object>();
		
		KeluhanPelanggan resultModel = keluhanPelangganDao.save(keluhanPelanggan);
		
		if(CommonUtil.isNotNullOrEmpty(keluhanPelanggan)){
			result.put("data", resultModel.getId());
		}
		return result;
	}

	@Override
	public Map<String, Object> updateKeluhanPelanggan(KeluhanPelangganVO vo) {
		KeluhanPelanggan keluhanPelanggan = new KeluhanPelanggan();
		if(CommonUtil.isNotNullOrEmpty(vo)){
			keluhanPelanggan = keluhanPelangganConverter.transferVOToModel(vo, new KeluhanPelanggan());
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getRuangan())){
			keluhanPelanggan.setRuangan(ruanganConverter.transferVOToModel(vo.getRuangan(), new Ruangan()));
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getPekerjaan())){
			keluhanPelanggan.setPekerjaan(pekerjaanConverter.transferVOToModel(vo.getPekerjaan(), new Pekerjaan()));
		}
		Map<String, Object> result = new HashMap<String,Object>();
		
		KeluhanPelanggan resultModel = keluhanPelangganDao.save(keluhanPelanggan);
		
		if(CommonUtil.isNotNullOrEmpty(keluhanPelanggan)){
			result.put("data", resultModel.getId());
		}
		return result;
	}

	@Override
	public Map<String, Object> findAllKeluhanPelanggan() {
		List<KeluhanPelanggan> list = new ArrayList<KeluhanPelanggan>();
		Map<String, Object> result = new HashMap<String,Object>();
		list = (List<KeluhanPelanggan>) keluhanPelangganDao.findAll();
		
		if(CommonUtil.isNotNullOrEmpty(list)){
			result.put("data", list);
		}
		return result;
	}
	
	//add by iwankasan 19062017
	//getKeluahanPelangganByPeriod
	public Map<String, Object> getKeluhanPelangganByPeriod(Integer bulan, Integer tahun) {
		Map <String, Object> result = new HashMap<>();
		
		List<Map<String, Object>> listdata =  this.keluhanPelangganDao.getKeluhanPelangganByPeriod(tahun, bulan);
		
		if (CommonUtil.isNotNullOrEmpty(listdata)) {
			result.put("data", listdata);
		}
		return result;
	}

	@Override
	public Map<String, Object> getPekerjaan() {
		Map<String, Object> result = new HashMap<>();
		result.put("data", this.keluhanPelangganDao.getPekerjaan());
		return result;
	}
	
	

}
